
_position:
	PUSH       28
	PUSH       29
	IN         28, 93
	IN         29, 94
	SBIW       28, 1
	OUT        93, 28
	OUT        94, 29
	ADIW       28, 1
;bluetooth_car.c,18 :: 		void position(){
;bluetooth_car.c,20 :: 		SERVO = 1;
	SBI        56, 3
;bluetooth_car.c,22 :: 		for (i=0; i<=pos; i++) Delay_us(85);
	LDI        27, 0
	STD        Y+0, 27
L_position0:
	LDD        17, Y+0
	LDS        16, _pos+0
	CP         16, 17
	BRSH       L__position13
	JMP        L_position1
L__position13:
	LDI        16, 113
	DEC        16
	BRNE       $-1
	NOP
	LDD        16, Y+0
	SUBI       16, 255
	STD        Y+0, 16
	JMP        L_position0
L_position1:
;bluetooth_car.c,23 :: 		SERVO = 0;
	CBI        56, 3
;bluetooth_car.c,24 :: 		Delay_ms(12);
	LDI        17, 63
	LDI        16, 85
	DEC        16
	BRNE       $-1
	DEC        17
	BRNE       $-3
	NOP
	NOP
;bluetooth_car.c,25 :: 		}
L_endposition:
	OUT        93, 28
	OUT        94, 29
	POP        29
	POP        28
	RET
; end of _position

_action:
;bluetooth_car.c,28 :: 		void action(){
;bluetooth_car.c,30 :: 		if ((uart_rd & 0b00000011)>0){        // faulty byte received, since last two bits aren't used
	LDS        16, _uart_rd+0
	MOV        17, 16
	ANDI       17, 3
	LDI        16, 0
	CP         16, 17
	BRLO       L__action15
	JMP        L_action3
L__action15:
;bluetooth_car.c,32 :: 		PORTB = 0;
	LDI        27, 0
	OUT        56, 27
;bluetooth_car.c,33 :: 		UART1_Write(0b00000011);           // send error, ie faulty bits
	LDI        27, 3
	PUSH       27
	CALL       _UART1_Write+0
	IN         26, 93
	IN         27, 94
	ADIW       26, 1
	OUT        93, 26
	OUT        94, 27
;bluetooth_car.c,34 :: 		pos = 14;                          // compensate for off-center rotor placement, 1.5ms should be standard
	LDI        27, 14
	STS        _pos+0, 27
;bluetooth_car.c,35 :: 		}else{
	JMP        L_action4
L_action3:
;bluetooth_car.c,37 :: 		UART1_Write(uart_rd);              // send response
	LDS        16, _uart_rd+0
	PUSH       16
	CALL       _UART1_Write+0
	IN         26, 93
	IN         27, 94
	ADIW       26, 1
	OUT        93, 26
	OUT        94, 27
;bluetooth_car.c,38 :: 		if ((uart_rd & 0b00001000)>0){
	LDS        16, _uart_rd+0
	MOV        17, 16
	ANDI       17, 8
	LDI        16, 0
	CP         16, 17
	BRLO       L__action16
	JMP        L_action5
L__action16:
;bluetooth_car.c,39 :: 		pos = 9;
	LDI        27, 9
	STS        _pos+0, 27
;bluetooth_car.c,40 :: 		}else if ((uart_rd & 0b00000100)>0){
	JMP        L_action6
L_action5:
	LDS        16, _uart_rd+0
	MOV        17, 16
	ANDI       17, 4
	LDI        16, 0
	CP         16, 17
	BRLO       L__action17
	JMP        L_action7
L__action17:
;bluetooth_car.c,41 :: 		pos = 18;
	LDI        27, 18
	STS        _pos+0, 27
;bluetooth_car.c,42 :: 		}else{
	JMP        L_action8
L_action7:
;bluetooth_car.c,43 :: 		pos = 14;                      // compensate for off-center rotor placement
	LDI        27, 14
	STS        _pos+0, 27
;bluetooth_car.c,44 :: 		}
L_action8:
L_action6:
;bluetooth_car.c,45 :: 		PORTB = uart_rd & 0xF0;
	LDS        16, _uart_rd+0
	ANDI       16, 240
	OUT        56, 16
;bluetooth_car.c,46 :: 		}
L_action4:
;bluetooth_car.c,47 :: 		}
L_endaction:
	RET
; end of _action

_main:
	LDI        27, 255
	OUT        93, 27
	LDI        27, 0
	OUT        94, 27
;bluetooth_car.c,50 :: 		void main() {
;bluetooth_car.c,51 :: 		UART1_Init(9600);                   // Initialize UART module at 9600 bps
	SBI        43, 1
	LDI        27, 51
	OUT        41, 27
	LDI        27, 0
	OUT        34, 27
	CALL       _UART1_Init+0
;bluetooth_car.c,52 :: 		Delay_ms(100);                      // Wait for UART module to stabilize
	LDI        18, 3
	LDI        17, 8
	LDI        16, 120
	DEC        16
	BRNE       $-1
	DEC        17
	BRNE       $-3
	DEC        18
	BRNE       $-5
;bluetooth_car.c,53 :: 		DDRB = 0b11111000;                  // PORTB as output, save PB0, PB1 and PB2 which aren't used
	LDI        27, 248
	OUT        55, 27
;bluetooth_car.c,54 :: 		PORTB = 0;                          // Initialize portb
	LDI        27, 0
	OUT        56, 27
;bluetooth_car.c,56 :: 		while (1)
L_main9:
;bluetooth_car.c,58 :: 		if (UART1_Data_Ready())           // If data is received,
	CALL       _UART1_Data_Ready+0
	TST        16
	BRNE       L__main19
	JMP        L_main11
L__main19:
;bluetooth_car.c,60 :: 		uart_rd = UART1_Read();        // read the received data
	CALL       _UART1_Read+0
	STS        _uart_rd+0, 16
;bluetooth_car.c,61 :: 		}
L_main11:
;bluetooth_car.c,62 :: 		action();                         // write outputs
	CALL       _action+0
;bluetooth_car.c,63 :: 		position();                       // posistion servo
	CALL       _position+0
;bluetooth_car.c,64 :: 		}
	JMP        L_main9
;bluetooth_car.c,65 :: 		}
L_endmain:
	JMP        L_endmain
; end of _main
